
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>web day19 Service层处理事务(利用ThreadLocal),TxQueryRunner小工具,单表练习(增删改查操作),分页 / 憋错料</title>

    <meta name="description" content="web day19 Service层处理事务(利用ThreadLocal),TxQueryRunner小工具,单表练习(增删改查操作),分页 Service事务 DAO中不是处理事务的地方,因为DAO中的每个方法都是对数据库的一次操作 在Service中不应该出现Connection,它应该只在DAO中出现, 因为它是JDBC的东西,JDBC的东西是用来连接数据库的 修改JdbcUtils 我们把对事务的开启和关闭放到JdbcUtils中,在Service中调用JdbcUtils的方法来完成事务的处理, 但在Service中就不会再出现Connection这一&quot;禁忌&quot;了. 代码 public class JdbcU ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">web day19 Service层处理事务(利用ThreadLocal),TxQueryRunner小工具,单表练习(增删改查操作),分页</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>Service事务</h1>
<p>DAO中不是处理事务的地方，因为DAO中的每个方法都是对数据库的一次操作</p>
<p>在Service中不应该出现Connection，它应该只在DAO中出现，</p>
<p>因为它是JDBC的东西，JDBC的东西是用来连接数据库的</p>
<h1>修改JdbcUtils</h1>
<p>我们把对事务的开启和关闭放到JdbcUtils中，在Service中调用JdbcUtils的方法来完成事务的处理，</p>
<p>但在Service中就不会再出现Connection这一“禁忌”了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjgyMzQ3MzQ3Mjc=.jpg"></p>
<p>代码</p>
<pre>public class JdbcUtils {
	// 配置文件的默认配置！要求你必须给出c3p0-config.xml！！！
	private static ComboPooledDataSource dataSource = new ComboPooledDataSource();

	// 它是事务专用连接！
	private static ThreadLocal&lt;Connection&gt; tl = new ThreadLocal&lt;Connection&gt;();

	/**
	 * 使用连接池返回一个连接对象
	 * @return
	 * @throws SQLException
	 */
	public static Connection getConnection() throws SQLException {
		Connection con = tl.get();
		// 当con不等于null，说明已经调用过beginTransaction()，表示开启了事务！
		if(con != null) return con;
		return dataSource.getConnection();
	}

	/**
	 * 返回连接池对象！
	 * @return
	 */
	public static DataSource getDataSource() {
		return dataSource;
	}

	/**
	 * 开启事务
	 * 1. 获取一个Connection，设置它的setAutoComnmit(false)
	 * 2. 还要保证dao中使用的连接是我们刚刚创建的！
	 * --------------
	 * 1. 创建一个Connection，设置为手动提交
	 * 2. 把这个Connection给dao用！
	 * 3. 还要让commitTransaction或rollbackTransaction可以获取到！
	 * @throws SQLException
	 */
	public static void beginTransaction() throws SQLException {
		Connection con = tl.get();
		if(con != null) throw new SQLException(&quot;已经开启了事务，就不要重复开启了！&quot;);
		/*
		 * 1. 给con赋值！
		 * 2. 给con设置为手动提交！
		 */
		con = getConnection();//给con赋值，表示事务已经开始了
		con.setAutoCommit(false);

		tl.set(con);//把当前线程的连接保存起来！
	}

	/**
	 * 提交事务
	 * 1. 获取beginTransaction提供的Connection，然后调用commit方法
	 * @throws SQLException
	 */
	public static void commitTransaction() throws SQLException {
		Connection con = tl.get();//获取当前线程的专用连接
		if(con == null) throw new SQLException(&quot;还没有开启事务，不能提交！&quot;);
		/*
		 * 1. 直接使用con.commit()
		 */
		con.commit();
		con.close();
		// 把它设置为null，表示事务已经结束了！下次再去调用getConnection()返回的就不是con了
		tl.remove();//从tl中移除连接
	}

	/**
	 * 提交事务
	 * 1. 获取beginTransaction提供的Connection，然后调用rollback方法
	 * @throws SQLException
	 */
	public static void rollbackTransaction() throws SQLException {
		Connection con = tl.get();
		if(con == null) throw new SQLException(&quot;还没有开启事务，不能回滚！&quot;);
		/*
		 * 1. 直接使用con.rollback()
		 */
		con.rollback();
		con.close();
		tl.remove();
	}

	/**
	 * 释放连接　
	 * @param connection
	 * @throws SQLException
	 */
	public static void releaseConnection(Connection connection) throws SQLException {
		Connection con = tl.get();
		/*
		 * 判断它是不是事务专用，如果是，就不关闭！
		 * 如果不是事务专用，那么就要关闭！
		 */
		// 如果con == null，说明现在没有事务，那么connection一定不是事务专用的！
		if(con == null) connection.close();
		// 如果con != null，说明有事务，那么需要判断参数连接是否与con相等，若不等，说明参数连接不是事务专用连接
		if(con != connection) connection.close();
	}</pre>
<h1>TxQueryRunner小工具</h1>
<p>自动处理连接的关闭,无需再传递连接参数,自动传递</p>
<p>通过继承QueryRunner类 ,同时重写了所有没有接连参数传递的方法(重写都加上了)</p>
<p>代码</p>
<pre>/**
 * 这个类中的方法，自己来处理连接的问题
 * 无需外界传递！　
 * 怎么处理的呢？
 *   通过JdbcUtils.getConnection()得到连接！有可能是事务连接，也可能是普通的连接！
 *   JdbcUtils.releaseConnection()完成对连接的释放！如果是普通连接，关闭之！
 * @author cxf
 *
 */
public class TxQueryRunner extends QueryRunner {
	@Override
	public int[] batch(String sql, Object[][] params) throws SQLException {
		/*
		 * 1. 得到连接
		 * 2. 执行父类方法，传递连接对象
		 * 3. 释放连接
		 * 4. 返回值
		 */
		Connection con = JdbcUtils.getConnection();
		int[] result = super.batch(con, sql, params);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public &lt;T&gt; T query(String sql, Object param, ResultSetHandler&lt;T&gt; rsh)
			throws SQLException {
		Connection con = JdbcUtils.getConnection();
		T result = super.query(con, sql, param, rsh);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public &lt;T&gt; T query(String sql, Object[] params, ResultSetHandler&lt;T&gt; rsh)
			throws SQLException {
		Connection con = JdbcUtils.getConnection();
		T result = super.query(con, sql, params, rsh);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public &lt;T&gt; T query(String sql, ResultSetHandler&lt;T&gt; rsh, Object... params)
			throws SQLException {
		Connection con = JdbcUtils.getConnection();
		T result = super.query(con, sql, rsh, params);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public &lt;T&gt; T query(String sql, ResultSetHandler&lt;T&gt; rsh) throws SQLException {
		Connection con = JdbcUtils.getConnection();
		T result = super.query(con, sql, rsh);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public int update(String sql) throws SQLException {
		Connection con = JdbcUtils.getConnection();
		int result = super.update(con, sql);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public int update(String sql, Object param) throws SQLException {
		Connection con = JdbcUtils.getConnection();
		int result = super.update(con, sql, param);
		JdbcUtils.releaseConnection(con);
		return result;
	}

	@Override
	public int update(String sql, Object... params) throws SQLException {
		Connection con = JdbcUtils.getConnection();
		int result = super.update(con, sql, params);
		JdbcUtils.releaseConnection(con);
		return result;
	}
}
</pre>
<h1>单表的增删改查练习</h1>
<h2>添加客户分析</h2>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjkwMDEzMzgzMTY=.jpg"></p>
<p>add.jsp→CustomerServlet#add()显示添加成功！</p>
<p>代码的实现</p>
<p>DAO#addCustomer(Customer c)：</p>
<p>给出sql语句的模板</p>
<p>把参数c转换成一个Object[]</p>
<p>调用QueryRunner的update方法。</p>
<p>Service#addCustomer(Customer c)：</p>
<p>直接调用dao的addCustomer(c);</p>
<h2>查看客户分析</h2>
<h3>查看所有用户信息列表</h3>
<p>top.jsp→CustomerServlet#findAll()→list.jsp</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjkwMDE3MTQ5MTE=.jpg"></p>
<p>DAO：</p>
<p>sql = “select * from t_customer”;</p>
<p>qr.query()，需要把结果集映射成List&lt;Customer&gt;，所以使用BeanListHandler</p>
<h3>条件查询</h3>
<p>query.jsp &nbsp;CustomerServlet#query() &nbsp;list.jsp</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjkwMDIwMTMxMTU=.jpg"></p>
<h2>修改客户</h2>
<p>按id查询流程</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjkwMDIyMDQwNTQ=.jpg"></p>
<p>编辑流程</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjkwMDIzMTA1NTQ=.jpg"></p>
<h2>删除客户</h2>
<p>1.当用户在list.jsp页面中点击“删除”时，通过CustomerServlet的delPre方法来处理：</p>
<p>2.获取cid；</p>
<p>3.通过cid获取Customer对象；</p>
<p>4.把Customer对象保存到request中</p>
<p>5.转发到del.jsp</p>
<p>2.1当用户在del.jsp页面点击删除时，通过Customer的del方法来处理：</p>
<p>2.2获取cid</p>
<p>2.3通过CustomerService来完成删除</p>
<p>3.向页面输出“删除成功”</p>
<p>代码</p>
<p>web层</p>
<pre>/**
 * Web层
 * @author cxf
 *
 */
public class CustomerServlet extends BaseServlet {
	private CustomerService customerService = new CustomerService();

	/**
	 * 添加客户
	 */
	public String add(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		/*
		 * 1. 封装表单数据到Customer对象
		 * 2. 补全：cid，使用uuid
		 * 3. 使用service方法完成添加工作
		 * 4. 向request域中保存成功信息
		 * 5. 转发到msg.jsp
		 */
		Customer c = CommonUtils.toBean(request.getParameterMap(), Customer.class);
		c.setCid(CommonUtils.uuid());
		customerService.add(c);
		request.setAttribute(&quot;msg&quot;, &quot;恭喜，添加客户成功！&quot;);
		return &quot;f:/msg.jsp&quot;;
	}

	/**
	 * 查询所有
	 * @param request
	 * @param response
	 * @return
	 * @throws ServletException
	 * @throws IOException
	 */
	public String findAll(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		/*
		 * 1. 调用service得到所有客户
		 * 2. 保存到request域
		 * 3. 转发到list.jsp
		 */
		request.setAttribute(&quot;cstmList&quot;, customerService.findAll());
		return &quot;f:/list.jsp&quot;;
	}

	/**
	 * 编辑之前的加载工作
	 * @param request
	 * @param response
	 * @return
	 * @throws ServletException
	 * @throws IOException
	 */
	public String preEdit(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		/*
		 * 1. 获取cid
		 * 2. 使用cid来调用service方法，得到Customer对象
		 * 3. 把Customer保存到request域中
		 * 4. 转发到edit.jsp显示在表单中
		 */
		String cid = request.getParameter(&quot;cid&quot;);
		Customer cstm = customerService.load(cid);
		request.setAttribute(&quot;cstm&quot;, cstm);
		return &quot;f:/edit.jsp&quot;;
	}

	/**
	 * 编辑方法
	 * @param request
	 * @param response
	 * @return
	 * @throws ServletException
	 * @throws IOException
	 */
	public String edit(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		/*
		 * 1. 封装表单数据到Customer对象中
		 * 2. 调用service方法完成修改
		 * 3. 保存成功信息到request域
		 * 4. 转发到msg.jsp显示成功信息
		 */
		// 已经封装了cid到Customer对象中
		Customer c = CommonUtils.toBean(request.getParameterMap(), Customer.class);
		customerService.edit(c);
		request.setAttribute(&quot;msg&quot;, &quot;恭喜，编辑客户成功！&quot;);
		return &quot;f:/msg.jsp&quot;;
	}

	public String query(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		/*
		 * 1. 封装表单数据到Customer对象中，它只有四个属性（cname、gender、cellphone、email）
		 *   它就是一个条件
		 * 2. 使用Customer调用service方法，得到List&lt;Customer&gt;
		 * 3. 保存到request域中
		 * 4. 转发到list.jsp
		 */
		Customer criteria = CommonUtils.toBean(request.getParameterMap(), Customer.class);
		List&lt;Customer&gt; cstmList = customerService.query(criteria);
		request.setAttribute(&quot;cstmList&quot;, cstmList);
		return &quot;/list.jsp&quot;;
	}
}
</pre>
<p>dao层(持久层)</p>
<pre>/**
 * 持久层
 *
 * @author cxf
 *
 */
public class CustomerDao {
	private QueryRunner qr = new TxQueryRunner();

	/**
	 * 添加客户
	 *
	 * @param c
	 */
	public void add(Customer c) {
		try {
			String sql = &quot;insert into t_customer values(?,?,?,?,?,?,?)&quot;;
			Object[] params = { c.getCid(), c.getCname(), c.getGender(),
					c.getBirthday(), c.getCellphone(), c.getEmail(),
					c.getDescription()};
			qr.update(sql, params);
		} catch(SQLException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * 查询所有
	 * @return
	 */
	public List&lt;Customer&gt; findAll() {
		try {
			String sql = &quot;select * from t_customer&quot;;
			return qr.query(sql, new BeanListHandler&lt;Customer&gt;(Customer.class));
		} catch(SQLException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * 加载客户
	 * @param cid
	 * @return
	 */
	public Customer load(String cid) {
		try {
			String sql = &quot;select * from t_customer where cid=?&quot;;
			return qr.query(sql, new BeanHandler&lt;Customer&gt;(Customer.class), cid);
		} catch(SQLException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * 编辑客户
	 * @param c
	 */
	public void edit(Customer c) {
		try {
			String sql = &quot;update t_customer set cname=?,gender=?,birthday=?,&quot; +
					&quot;cellphone=?,email=?,description=? where cid=?&quot;;
			Object[] params = {c.getCname(), c.getGender(),
					c.getBirthday(), c.getCellphone(), c.getEmail(),
					c.getDescription(), c.getCid()};
			qr.update(sql, params);
		} catch(SQLException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * 多条件组合查询
	 * @param criteria
	 * @return
	 */
	public List&lt;Customer&gt; query(Customer criteria) {
		try {
			/*
			 * 1. 给出sql模板
			 * 2. 给出参数
			 * 3. 调用query方法，使用结果集处理器：BeanListHandler
			 */
			/*
			 * 一、　给出sql模板
			 * 二、　给出参数！
			 */
			/*
			 * 1. 给出一个sql语句前半部
			 */
			StringBuilder sql = new StringBuilder(&quot;select * from t_customer where 1=1&quot;);
			/*
			 * 2. 判断条件，完成向sql中追加where子句
			 */
			/*
			 * 3. 创建一个ArrayList，用来装载参数值
			 */
			List&lt;Object&gt; params = new ArrayList&lt;Object&gt;();
			String cname = criteria.getCname();
			if(cname != null &amp;&amp; !cname.trim().isEmpty()) {
				sql.append(&quot; and cname like ?&quot;);
				params.add(&quot;%&quot; + cname + &quot;%&quot;);
			}

			String gender = criteria.getGender();
			if(gender != null &amp;&amp; !gender.trim().isEmpty()) {
				sql.append(&quot; and gender=?&quot;);
				params.add(gender);
			}

			String cellphone = criteria.getCellphone();
			if(cellphone != null &amp;&amp; !cellphone.trim().isEmpty()) {
				sql.append(&quot; and cellphone like ?&quot;);
				params.add(&quot;%&quot; + cellphone + &quot;%&quot;);
			}

			String email = criteria.getEmail();
			if(email != null &amp;&amp; !email.trim().isEmpty()) {
				sql.append(&quot; and email like ?&quot;);
				params.add(&quot;%&quot; + email + &quot;%&quot;);
			}

			/*
			 * 三、执行query
			 */
			return qr.query(sql.toString(),
					new BeanListHandler&lt;Customer&gt;(Customer.class),
					params.toArray());
		} catch(SQLException e) {
			throw new RuntimeException(e);
		}
	}
}
</pre>
<p><h1>分页</h1>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 03:09:03 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>web day19 Service层处理事务(利用ThreadLocal),TxQueryRunner小工具,单表练习(增删改查操作),分页的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jrBPA0.html" rel="bookmark">【框架】&lbrack;Hibernate&rsqb;利用Hibernate进行单表的增删改查-Web实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/qq_26525215 本文源自[大学之旅_谙忆的博客] 前面两篇博客已经将Hibernate的基础知识讲解得差不多了,差不多到写实例的时候了. 本篇只用hibernate进行单表的增删改查. 应用Hibernate,对students表进行增删改查. service层和DAO层,我都是直接写实现类了(因为这里主要是演示一下Hibernate的使用),如果是开发项目,注意一定要写接口! 准备数据库: 首先准备一个students表: cr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QdEOQ3.html" rel="bookmark">django 利用ORM对单表进行增删改查</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				牛小妹上周末,一直在尝试如何把数据库的数据弄到界面上.毕竟是新手,搞不出来,文档也看不懂.不过没关系,才刚上大学.今晚我们就来解释下,要把数据搞到界面的第一步.先把数据放到库里,然后再把数据从库里拿出来. 以下内容,参考django官方文档 . 1.创建MODEL 这里和官方文档一致.直接拷出来,放到一个叫models的py文件里面.若是你的项目中没有,一定不要觉得无处写代码.你自己建一个即可 同步数据库: 执行以下命令.不懂的可以参考:django连接mysql python manage.p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n4ADVd3.html" rel="bookmark">SpringBoot JPA实现增删改查、分页、排序、事务操作等功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天给大家介绍一下SpringBoot中JPA的一些常用操作,例如:增删改查.分页.排序.事务操作等功能.下面先来介绍一下JPA中一些常用的查询操作: //And --- 等价于 SQL 中的 and 关键字,比如 findByHeightAndSex(int height,char sex): public List&lt;User&gt; findByHeightAndSex(int height,char sex); // Or --- 等价于 SQL 中的 or 关键字,比如 findByHeig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rbYV93.html" rel="bookmark">JavaWeb程序利用Servlet的对SQLserver增删改查操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:学了几天终于将增删改查的操作掌握了,也发现了一些问题,所以总结一下. 重点:操作数据库主要用的是SQL语句跟其他无关. 一:前提知识:PreparedStatement PreperedStatement是Statement的子类,它的实例对象可以通过调用Connection.preparedStatement()方法获得,相对于Statement对象而言:PreperedStatement可以避免SQL注入的问题. Statement会使数据库频繁编译SQL,可能造成数据库缓冲区溢出.P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jGAeo3.html" rel="bookmark">利用SpringBoot实现RestFul风格的增删改查操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				会遇到的问题:1.在提交delete请求时,可能会报405错误,解决办法在配置文件中加入在配置文件中加入spring.mvc.hiddenmethod.filter.enabled=true启用隐藏方法过滤器 2.可能会遇到Error creating bean with name 'requestMappingHandlerMapping' defined in class path resource ,解决办法:自己检查controller的请求头是不是有重复的 说明:这个小项目没有使用数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YgnXX4.html" rel="bookmark">创建支持CRUD&lpar;增删改查&rpar;操作的Web API</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:准备工作 你可以直接下载源码查看 Download the completed project.     下载完整的项目 CRUD是指“创建(C).读取(R).更新(U)和删除(D)”,它们是四个基本的数据库操作.许多HTTP服务也会通过REST或类REST的API模拟CRUD操作. 在本教程中,我们将建立一个十分简单的Web API来管理一列产品. 每个产品包含一个name(名称).price(价格)和category(分类)(如,“toys(玩具)”.“hardware(硬件)”等),还			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pv7gg0.html" rel="bookmark">关于利用PHP访问MySql数据库的逻辑操作以及增删改查实例操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP访问MySql数据库 &lt;?php //造连接对象$db = new MySQLi(&quot;localhost&quot;,&quot;root&quot;,&quot;&quot;,&quot;0710_test&quot;); //写SQL语句$sql = &quot;select * from student&quot;;//检测连接数据库是否成功,失败返回&quot;连接失败&quot;,并退出程序 if(mysqli_connect_error()){    die(&quot;连			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWYqdL3.html" rel="bookmark">利用SQLiteOpenHelper创建数据库，进行增删改查操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android中提供SQLiteOpenHelper类,在该类的构造器中,调用Context中的方法创建并打开一个指定名称的数据库对象.继承和扩展SQLiteOpenHelper类主要做的工作就是重写以下两个方法.onCreate(SQLiteDatabase db) : 当数据库被首次创建时执行该方法,一般将创建表等初始化操作在该方法中执行. onUpgrade(SQLiteDatabse dv, int oldVersion,int new Version):当打开数据库时传入的版本号与当前			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KYdZ94.html" rel="bookmark">权限管理系统之LayUI实现页面增删改查和弹出层交互</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于对LayUI框架不太熟悉,昨天抽空看了下LayUI的文档,今天在网上找了使用LayUI进行增删改查相关内容,自己照葫芦画了个瓢,画瓢部分不是很难,主要是下午遇到了一个弹出层的问题耗时比较久. 同一项目,设计风格都差不多,对于涉及单个数据表的页面,基本都是增删改查,布局都是差不多,实际项目中都是复制.粘贴过来改下数据基本就能完成80%,后续就是修修补补或者是要实现一些特殊需求,记得刚参加工作时,老大直接给了一个已经做好的模板页面让我比对着手动敲一遍,当时觉得重复操作没啥用,现在再看觉得作用很大			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412BDqM.html" rel="bookmark" class="title">宇宙时空论&mdash;&mdash;黑洞</a>
					<div>
						黑洞指 一种超高密度天体,其引力之强足以拉住光,亦无光可反射,故名“黑洞“.    目前存在的大部分黑洞都是由恒星因自身引力坍缩而来.恒星开始时其内部的氢元素在高温高压条件下获得许多能量,在高速运动中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knpPEM.html" rel="bookmark" class="title">有趣的C语言小程序</a>
					<div>
						判断下面程序输出的内容: #define _CRT_SECURE_NO_WARNINGS 1 #include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r51WX0.html" rel="bookmark" class="title">Golang的简明安装指南</a>
					<div>
						引言: Go language现在是大名鼎鼎,很多的开源项目都是基于go来做的,比如codis, ethereum等都用到了go lang,所以免不了要使用这个东东,本文将简明介绍安装步骤以及环境变量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OaaRGM.html" rel="bookmark" class="title">笛卡尔 我思故我在</a>
					<div>
						我思故我在(I think, therefore I am)的意思是&quot;思考的我(I as the thinking being)是我(the subject)的第一真实所在&quot;.这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4peRLKM.html" rel="bookmark" class="title">注意&amp;lt&semi;a&amp;gt&semi;标签有空白和没有空白是不一样的</a>
					<div>
						&lt;a href=&quot;index.php?extendModule-venueBooking-index-dateList-{$type}-{$id}-fromDateList-{$row ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXE2b3.html" rel="bookmark" class="title">Laravel项目和其它项目共享session问题</a>
					<div>
						我这边总结一下,也许以后有人会需要,其实Laravel的session并不是用PHP自带的session管理器.而是完完全全自己实现了一个.注意是完完全全自己实现的,并不是传统意义上用session_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzg9J0.html" rel="bookmark" class="title">Oracle clob 操作函数</a>
					<div>
						1 instr(objClob,objstr,beginIndex,appearIndex)objClob:带检索目对象,可以是clob,stringobjstr: 需要验证的字符串beginInde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzo2w0.html" rel="bookmark" class="title">送送送送</a>
					<div>
						http://kayosite.com/block-formatting-contexts-in-detail.html http://www.nenew.net/use-clearfix-to-cl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpPEV0.html" rel="bookmark" class="title">Dell服务器之常用管理命令</a>
					<div>
						具体信息    指令 查看机器型号    # dmidecode | grep &quot;Product&quot; 查看厂商    # dmidecode| grep  &quot;Manufac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQoVJM.html" rel="bookmark" class="title">bash编程 &colon;循环语句</a>
					<div>
						循环: 将循环体代码执行0.1或多次 进入条件:进入循环的条件 退出条件:循环终止的条件 for循环: for VARIABLE in LIST; do 循环体 done 示例1:写一个脚本,创建20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwr6P4.html" rel="bookmark" class="title">学java教程之面向对象&lpar;三&rpar;</a>
					<div>
						学编程吧学java教程之面向对象发布了,欢迎通过xuebiancheng8.com来访问 上面两次分析了类和对象,以及如何定义对象.下面来分析下如何使用对象 下面先定义一个类 public class ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLWaq3.html" rel="bookmark" class="title">Swift2&period;0 UITextView 和 UITextFile 的使用</a>
					<div>
						在Swift2.0中,UITextFile 和 UITextView 的使用总体上和在OC中是一样的,今天只是给大家一段代码,然后说UITextView里面的光标位置的问题.先看他们使用的简单的代码  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBxPQj3.html" rel="bookmark" class="title">一些页面元素的遍历&comma;元素的选择</a>
					<div>
						&lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeBehind=&quot;DeviceChecks1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEdGa0.html" rel="bookmark" class="title">Effective Java提升Code Coverage代码涵盖率 - 就是爱Java</a>
					<div>
						虽然我们已经有了测试程序,但是如何得知是否已完整测试了主程序?,透过Code Coverage代码涵盖率,我们可以快速地得知,目前系统中,有多少程序中被测试过,不考虑成本跟投资效益比,涵盖率越高,代表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6p8Gy3.html" rel="bookmark" class="title">鼎立网络福州段</a>
					<div>
						鼎立通 位置 500元/月    无视任何80攻击,需要的联系我 福州27新段高防 100G 无视CC  1800元 200G 无视CC  3500元 GM开区福利,绝对性无视CC,C死退款 惠州纯高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mob11D4.html" rel="bookmark" class="title">Android第三方授权&lpar;新浪微博篇&rpar;</a>
					<div>
						Android第三方认证新浪微博,相对微信,也比较简单,并且sina给了一个sdk和sdkdemo,这个demo封装了许多,但是自己不准备记录这个demo,而是直接使用sdk 同样去sina官方下载s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQJXJ0.html" rel="bookmark" class="title">移动端页头推荐配置   出现找不到favicon&period;ico错误原因和解决方法</a>
					<div>
						favicon 在未指定 favicon 时,大多数浏览器会请求 Web Server 根目录下的 favicon.ico .为了保证 favicon 可访问,避免404,必须遵循以下两种方法之一:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0neBnPM.html" rel="bookmark" class="title">git merge的recursive策略和merge-base</a>
					<div>
						git的合并策略总共有3种,一种是resovle,一种是recursive,一种是octopus.其中resolve和recursive适用于合并2个branch,octopus适用于合并3个或者3个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JOdRnM.html" rel="bookmark" class="title">Android组件：Fragment切换后保存状态</a>
					<div>
						之前写的第一篇Fragment实例,和大多数人一开始学的一样,都是通过FragmentTransaction的replace方法来实现,replace方法相当于先移除remove()原来所有已存在的f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35PQWn0.html" rel="bookmark" class="title">Android&mdash;&mdash;SQLite实现面向对象CRUD</a>
					<div>
						现在有点焦虑,不想写代码了,故而写一下博文来放松一下. 刚刚学了android中SQLite的使用,其实倒也不难,但是与JDBC操作数据库相比,这个还是有点不顺手,而且我好久没写底层的封装了,使用SS ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
